﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Timers;
using Config;

namespace ConsoleApplication1
{
   
   public class EnemyTank
    {
        private int width;//长度
        private int x;  //最左端的横坐标长度
        private int previousX; //储存前一个位置
        private bool isRun; //判断小球是否在运动中
        private int y;
        int a = 0;
        private static Bullet ball = new Bullet(); //小球
        private static Tank bottom = new Tank();
        private Timer timer1;  //定时器   
        private static int interval = 200; //小球移动的速度
        private Direction direction; //方向，水平方向，垂直方向
        private int eTankStep=0;
        private int eTankDirection = 0;
        private Point point;  //坐标位置

        public Direction Direction
        {
            get { return direction; }
            set { direction = value; }
        }

        public bool IsRun
        {
            get { return isRun; }
            set { isRun = value; }
        }

        public int X
        {
            get { return x; }
            set { x = value; }
        }

        public int Y
        {
            get { return y; }
            set { y = value; }
        }

        public static int Interval
        {
            get { return interval; }
            set { interval = value; }
        }

        public int Width
        {
            get { return width; }
            set { width = value; }
        }

        public Point Point
        {
            get { return point; }
            set { point = value; }
        }

      
        public EnemyTank()
        {
            width = 3;
            x = From.Width / 2 ;
            previousX = x;
            y = 1;
            direction = new Direction(MoveType.Right);
            Direction = direction;
        }

        /// <summary>
        /// 坦克移动事件
        /// </summary>
        public void BallMoveEvent()
        {
            timer1 = new Timer();
            timer1.Interval = Interval;
            timer1.Enabled = true;
            timer1.Elapsed += new ElapsedEventHandler(timer_Elapsed);
        }

        /// <summary>
        /// 移动小球事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void timer_Elapsed(object sender, ElapsedEventArgs e)
        {
            lock (From.Map)
            {
                if (eTankStep == 0)
                {
                    eTankStep = TankMove();
                    eTankDirection = TankOfDirection();
                }
                HandleInput(eTankDirection);

                if (!Config.Config.isBulletEtank)
                {
                    Config.Config.killEnemyNum = Config.Config.killEnemyNum + 1;    //获得击杀敌方数量
                    Config.Config.fun();
                    Config.Config.funs();

                    DieDraw();   //绘制死亡
                    System.Threading.Thread.Sleep(150);
                    Clear(MoveType.Up);
                    timer1.Dispose();
                    Config.Config.isBulletEtank = true;

                    EnemyTank t = new EnemyTank();
                    System.Threading.Thread.Sleep(1000);
                    t.Draw(MoveType.Down);
                    t.BallMoveEvent();
                }
               
                eTankStep--;
            }
        }
       
        /// <summary>
        /// 绘制自身
        /// </summary>
        public void Draw(MoveType type)
        {

            Console.ForegroundColor = ConsoleColor.Yellow;
            lock (From.Map)
            {

                if (type == MoveType.Right)
                {
                    for (int i = x; i < x + width; i++)
                    {
                        for (int j = 0; j < 3; j++)
                        {
                            Console.SetCursorPosition(From.Left + 2 * i, From.Top + y + j);
                            if (j == 1)
                            {
                                switch (a)
                                {
                                    case 0:
                                        Console.Write(" ");
                                        break;
                                    case 1:
                                        Console.Write("█");
                                        break;
                                    case 2:
                                        Console.Write("―");
                                        break;
                                    default:
                                        break;
                                }

                            }
                            else
                            {
                                Console.Write("▓");
                            }


                            From.Map[i - 1, From.Top + y + j-1] = 3;
                        }

                        a++;
                    }
                    a = 0;
                }

                else if (type == MoveType.Left)
                {
                    for (int i = x; i < x + width; i++)
                    {
                        for (int j = 0; j < 3; j++)
                        {
                            Console.SetCursorPosition(From.Left + 2 * i, From.Top + y + j);
                            if (j == 1)
                            {
                                switch (a)
                                {
                                    case 0:
                                        Console.Write("―");
                                        break;
                                    case 1:
                                        Console.Write("█");
                                        break;
                                    case 2:
                                        Console.Write(" ");
                                        break;
                                    default:
                                        break;
                                }

                            }
                            else
                            {
                                Console.Write("▓");
                            }


                            From.Map[i - 1, From.Top + y + j-1] = 3;
                        }

                        a++;
                    }
                    a = 0;
                }
                else if (type == MoveType.Up)
                {
                    for (int i = x; i < x + width; i++)
                    {
                        for (int j = 0; j < 3; j++)
                        {
                            Console.SetCursorPosition(From.Left + 2 * i, From.Top + y + j);
                            if (a==1)
                            {
                                switch (j)
                                {
                                    case 0:
                                        Console.Write("︳");
                                        break;
                                    case 1:
                                        Console.Write("█");
                                        break;
                                    case 2:
                                        Console.Write(" ");
                                        break;
                                    default:
                                        break;
                                }
                            }
                            else
                            {
                                Console.Write("▓");
                            }

                            From.Map[i - 1, From.Top + y + j-1] = 3;
                        }

                        a++;
                    }
                    a = 0;
                }
                else if (type == MoveType.Down)
                {
                    for (int i = x; i < x + width; i++)
                    {
                        for (int j = 0; j < 3; j++)
                        {
                            Console.SetCursorPosition(From.Left + 2 * i, From.Top + y + j);
                            if (a == 1)
                            {
                                switch (j)
                                {
                                    case 0:
                                        Console.Write(" ");
                                        break;
                                    case 1:
                                        Console.Write("█");
                                        break;
                                    case 2:
                                        Console.Write("︳");
                                        break;
                                    default:
                                        break;
                                }
                            }
                            else
                            {
                                Console.Write("▓");
                            }

                            From.Map[i - 1, From.Top + y + j-1] = 3;
                        }

                        a++;
                    }
                    a = 0;
                }
            }
        }

       /// <summary>
       /// 绘制死亡
       /// </summary>
        public void DieDraw()
        {
             Console.ForegroundColor = ConsoleColor.Yellow;
             lock (From.Map)
             {
                 for (int i = x; i < x + width; i++)
                 {
                     for (int j = 0; j < 3; j++)
                     {
                         Console.SetCursorPosition(From.Left + 2 * i, From.Top + y + j);
                         if (j == 0)
                         {
                             switch (a)
                             {
                                 case 0:
                                     Console.Write("╯");
                                     break;
                                 case 1:
                                     Console.Write(" ");
                                     break;
                                 case 2:
                                     Console.Write("╰");
                                     break;
                                 default:
                                     break;
                             }

                         }
                         if (j == 1)
                         {
                             switch (a)
                             {
                                 case 0:
                                     Console.Write(" ");
                                     break;
                                 case 1:
                                     Console.Write("︳");
                                     break;
                                 case 2:
                                     Console.Write(" ");
                                     break;
                                 default:
                                     break;
                             }
                         }
                         if(j==2)
                         {
                             switch (a)
                             {
                                 case 0:
                                     Console.Write(" ");
                                     break;
                                 case 1:
                                     Console.Write("﹏");
                                     break;
                                 case 2:
                                     Console.Write(" ");
                                     break;
                                 default:
                                     break;
                             }
                         }


                         From.Map[i - 1, From.Top + y + j - 1] = 0;
                     }

                     a++;
                 }
             }
        }

       /// <summary>
       /// 获得坦克移动方向
       /// </summary>
       /// <returns></returns>
        private int TankOfDirection()
        {
            Random ran = new Random();
            return ran.Next(1, 5);
        }

       /// <summary>
       /// 获得坦克移动步数
       /// </summary>
       /// <returns></returns>
        private int TankMove()
        {
            Random ran = new Random();
            return ran.Next(3, 8);
        }
      
       /// <summary>
       /// 通过获得随机方向、步数控制坦克
       /// </summary>
       /// <param name="directions"></param>
       /// <returns></returns>
        public bool HandleInput(int directions)
        {
            bool state = true;
            switch (directions)
            {
                case 1:
                    Clear(MoveType.Left);
                    x = Collide(MoveType.Left);
                    Move(MoveType.Left);
                    break;

                case 2:
                    Clear(MoveType.Right);
                    x = Collide(MoveType.Right);
                    Move(MoveType.Right);
                    break;

                case 3:
                    Clear(MoveType.Up);
                     y = Collide(MoveType.Up);
                    Move(MoveType.Up);
                    break;

                case 4:
                    Clear(MoveType.Down);
                    y = Collide(MoveType.Down);
                    Move(MoveType.Down);
                   
                    break;

                default:
                    break;
            }
            return state;
        }

       /// <summary>
       /// 判断坦克是否碰到边框或者其他坦克
       /// </summary>
       /// <param name="type"></param>
       /// <returns></returns>
        public int Collide(MoveType type)
        {
            int tan = 0;

            //左
            if (type == MoveType.Left)
            {
                if (x<=1)
                {
                    tan = x;
                }
                else
                {
                    if (From.Map[x - 2, y-1] == 2 || From.Map[x - 2, y] == 2 || From.Map[x - 2, y+1] == 2)
                    {
                        tan = x;
                    }
                    else
                    {
                        x -= 1;
                        tan = x;
                    }
                  
                }
            }
          

            if (type == MoveType.Right)
            {
                if ( x >= From.Width - width + 1)
                {
                    tan = x;
                }
                else
                {
                    if (From.Map[x + 2, y-1] == 2 || From.Map[x + 2, y] == 2 || From.Map[x + 2, y+1] == 2)
                    {
                        tan = x;
                    }
                    else
                    {
                        x += 1;
                        tan = x;
                    }
                   
                }
            }
          
            if (type == MoveType.Up)
            {
                if (y <= 1)
                {
                    tan = y;
                }
                else
                {
                    if (From.Map[x - 1, y-2 ] == 2 || From.Map[x, y-2] == 2 || From.Map[x + 1, y-2] == 2)
                    {
                        tan = y;
                    }
                    else
                    {
                        y -= 1;
                        tan = y;
                    }
                }
            }
           
            if (type == MoveType.Down)
            {
                if ( y > From.Height - 3)
                {
                    tan = y;
                }
                else
                {
                    if (From.Map[x - 1, y+2] == 2 || From.Map[x, y+2] == 2 || From.Map[x + 1, y+2] == 2)
                    {
                        tan = y;
                    }
                    else
                    {
                        y += 1;
                        tan = y;
                    }
                   
                }
            }
         
            return tan;
        }

       /// <summary>
       /// 判断坦克是否碰到子弹
       /// </summary>
       /// <returns></returns>
        public bool BulletCollide()
        {

            bool isCollide = true;
            MoveType type = direction.LevelState;

            if (type == MoveType.Left)
            {
                if (From.Map[point.X - 1, point.Y - 1] == 3)
                {
                    isCollide = false;
                }
            }

            if (type == MoveType.Right)
            {
                if (From.Map[point.X - 1, point.Y - 1] == 3)
                {
                    isCollide = false;
                }
            }

            if (type == MoveType.Up)
            {
                if (From.Map[point.X - 1, point.Y - 1] == 3)
                {
                    isCollide = false;
                }
            }

            if (type == MoveType.Down)
            {
                if (From.Map[point.X - 1, point.Y - 1] == 3)
                {
                    isCollide = false;
                }
            }
            Config.Config.isBulletEtank = isCollide;
            return isCollide;
        }

        /// <summary>
        /// 移动
        /// </summary>
        /// <param name="type"></param>
        public void Move(MoveType type)
        {
            if (type == MoveType.Left)
            {
              
                Draw(MoveType.Left);
                Direction d=new Direction (MoveType.Left);
                
                Direction = d;

            }
            if (type == MoveType.Right)
            {
              
                Draw(MoveType.Right);
                Direction d = new Direction(MoveType.Right);
                Direction = d;
               
            }
            if (type == MoveType.Up)
            {
               
                Draw(MoveType.Up);
                Direction d = new Direction(MoveType.Up);
                Direction = d;
            }
            if (type == MoveType.Down)
            {
              
                Draw(MoveType.Down);
                Direction d = new Direction(MoveType.Down);
                //ball.Direction = d;
                Direction = d;
            }
        }

       /// <summary>
        /// 清空坦克移动后痕迹
       /// </summary>
       /// <param name="type"></param>
        public  void Clear(MoveType type)
        {
            lock (From.Map)
            {
                for (int i = 0; i <  3; i++)
                {
                    for (int j = 0; j < 3; j++)
                    {
                        if (type == MoveType.Left || type == MoveType.Right)
                        {
                            Console.SetCursorPosition(x * 2 + i*2, y + 3 - j - 1);
                            
                        }
                        else if (type == MoveType.Up)
                        {
                            Console.SetCursorPosition(x * 2 + i * 2, y + j);
                        }
                        else if (type == MoveType.Down)
                        {
                            Console.SetCursorPosition(x * 2 + i * 2, y + j);
                        }
                        Console.Write("  ");
                        From.Map[x+i-1, y+j-1] = 0;
                    }
                }
               
            }
        }
    }
}
