﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Timers;

namespace ConsoleApplication1
{

    public enum MoveType
    {
        Left,
        Right,
        Up,
        Down
    }
   public class Tank
    {

        private int width;//长度
        private int x;  //最左端的横坐标长度
        private int previousX; //储存前一个位置
        private bool isRun; //判断子弹是否在运动中
        private int y;
        int a = 0;
        private static Bullet bullet = new Bullet(); //子弹
        private static Tank tank = new Tank();
        public Timer timer;  //定时器  
        private static int interval = 100; //子弹移动的速度
        private Direction direction; //方向，水平方向，垂直方向

        public Direction Direction
        {
            get { return direction; }
            set { direction = value; }
        }


        public bool IsRun
        {
            get { return isRun; }
            set { isRun = value; }
        }

        public int X
        {
            get { return x; }
            set { x = value; }
        }
        public int Y
        {
            get { return y; }
            set { y = value; }
        }

        public static int Interval
        {
            get { return Tank.interval; }
            set { Tank.interval = value; }
        }

        public int Width
        {
            get { return width; }
            set { width = value; }
        }

        internal static Bullet Ball
        {
            get { return Tank.bullet; }
            set { Tank.bullet = value; }
        }


        public Tank()
        {
            width = 3;
            x = From.Width / 2 ;
            previousX = x;
            y = From.Height-2;
            direction = new Direction(MoveType.Right);
            Direction = direction;
        }

        /// <summary>
        /// 处理键盘输入
        /// </summary>
        public bool HandleInput()
        {
            ConsoleKeyInfo key;
            while (true)
            {
                key = Console.ReadKey(true);
                HandleInput(key);
            }
        }

        /// <summary>
        /// 子弹移动事件
        /// </summary>
        public void BallMoveEvent()
        {
            timer = new Timer();
            timer.Interval = Interval;
            timer.Enabled = true;
            timer.Elapsed += new ElapsedEventHandler(timer_Elapsed);
        }

        /// <summary>
        /// 移动子弹事件
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void timer_Elapsed(object sender, ElapsedEventArgs e)
        {
            lock (From.Map)
            {
                if (!bullet.Move())
                {
                    timer.Close();
                    isRun = false;
                }
            }
        }
       
        /// <summary>
        /// 绘制自身
        /// </summary>
        public void Draw(MoveType type)
        {
            lock (From.Map)
            {

                if (type == MoveType.Right)
                {
                    for (int i = x; i < x + width; i++)
                    {
                        for (int j = 0; j < 3; j++)
                        {
                            Console.SetCursorPosition(From.Left + 2 * i, From.Top + y + j);
                            if (j == 1)
                            {
                                Console.ForegroundColor = ConsoleColor.Red;
                                switch (a)
                                {
                                    case 0:
                                        Console.Write(" ");
                                        break;
                                    case 1:
                                        Console.Write("◆");
                                        break;
                                    case 2:
                                        Console.Write("―");
                                        break;
                                    default:
                                        break;
                                }

                            }
                            else
                            {
                                Console.ForegroundColor = ConsoleColor.Red;
                                Console.Write("▓");
                            }


                            From.Map[i - 1, From.Top + y + j-1] = 2;
                        }

                        a++;
                    }
                    a = 0;
                }

                else if (type == MoveType.Left)
                {
                    for (int i = x; i < x + width; i++)
                    {
                        for (int j = 0; j < 3; j++)
                        {
                            Console.SetCursorPosition(From.Left + 2 * i, From.Top + y + j);
                            if (j == 1)
                            {
                                Console.ForegroundColor = ConsoleColor.Red;
                                switch (a)
                                {
                                    case 0:
                                        Console.Write("―");
                                        break;
                                    case 1:
                                        Console.Write("◆");
                                        break;
                                    case 2:
                                        Console.Write(" ");
                                        break;
                                    default:
                                        break;
                                }

                            }
                            else
                            {
                                Console.ForegroundColor = ConsoleColor.Red;
                                Console.Write("▓");
                            }


                            From.Map[i - 1, From.Top + y + j-1] = 2;
                        }

                        a++;
                    }
                    a = 0;
                }
                else if (type == MoveType.Up)
                {
                    for (int i = x; i < x + width; i++)
                    {
                        for (int j = 0; j < 3; j++)
                        {
                            Console.SetCursorPosition(From.Left + 2 * i, From.Top + y + j);
                            if (a==1)
                            {
                                Console.ForegroundColor = ConsoleColor.Red;
                                switch (j)
                                {
                                    case 0:
                                        Console.Write("︳");
                                        break;
                                    case 1:
                                        Console.Write("◆");
                                        break;
                                    case 2:
                                        Console.Write(" ");
                                        break;
                                    default:
                                        break;
                                }
                            }
                            else
                            {
                                Console.ForegroundColor = ConsoleColor.Red;
                                Console.Write("▓");
                            }

                            From.Map[i - 1, From.Top + y + j-1] = 2;
                        }

                        a++;
                    }
                    a = 0;
                }
                else if (type == MoveType.Down)
                {
                    for (int i = x; i < x + width; i++)
                    {
                        for (int j = 0; j < 3; j++)
                        {
                            Console.SetCursorPosition(From.Left + 2 * i, From.Top + y + j);
                            if (a == 1)
                            {
                                Console.ForegroundColor = ConsoleColor.Red;
                                switch (j)
                                {
                                    case 0:
                                        Console.Write(" ");
                                        break;
                                    case 1:
                                        Console.Write("◆");
                                        break;
                                    case 2:
                                        Console.Write("︳");
                                        break;
                                    default:
                                        break;
                                }
                            }
                            else
                            {
                                Console.ForegroundColor = ConsoleColor.Red;
                                Console.Write("▓");
                            }

                            From.Map[i - 1, From.Top + y + j-1] = 2;
                        }

                        a++;
                    }
                    a = 0;
                }
            }
        }

        /// <summary>
        /// 获得键盘按键状态
        /// </summary>
        /// <returns></returns>
        public bool StartInput()
        {
            ConsoleKeyInfo key;
            while (true)
            {
                key = Console.ReadKey(true);
                if (!HandleInput(key))
                {
                    return false;
                }
            }
         
            return true;
        }

       /// <summary>
       /// 通过按键控制坦克
       /// </summary>
       /// <param name="key"></param>
       /// <returns></returns>
        public bool HandleInput(ConsoleKeyInfo key)
        {
            bool state = true;
            switch (key.Key)
            {
                case ConsoleKey.A:    //左
                    Clear(MoveType.Left);
                    x = Collide(MoveType.Left);
                    Move(MoveType.Left);
                    break;

                case ConsoleKey.D:    //右
                    Clear(MoveType.Right);
                    x = Collide(MoveType.Right);
                    Move(MoveType.Right);
                    break;

                case ConsoleKey.W:   //上
                    Clear(MoveType.Up);
                    y = Collide(MoveType.Up);
                    
                    Move(MoveType.Up);
                    break;

                case ConsoleKey.S:     //下
                    Clear(MoveType.Down);
                    y = Collide(MoveType.Down);
                    Move(MoveType.Down);
                   
                    break;

                case ConsoleKey.J:    //触发子弹
                    if (!isRun)
                    {
                        state = false;

                        isRun = true;
                        Direction d = new Direction(direction.LevelState);
                        bullet.Direction = d;

                        if (direction.LevelState == MoveType.Left)
                        {
                            Point p = new Point(X, Y + 1, true);
                            bullet.Point = p;
                        }
                        else if (direction.LevelState == MoveType.Right)
                        {
                            Point p = new Point(X + 2, Y + 1, true);
                            bullet.Point = p;

                        }
                        else if (direction.LevelState == MoveType.Up)
                        {
                            Point p = new Point(X + 1, Y, true);
                            bullet.Point = p;
                        }
                        else if (direction.LevelState == MoveType.Down)
                        {
                            Point p = new Point(X + 1, Y + 2, true);
                            bullet.Point = p;
                        }
                    }

                   
                    
                     
                    break;
                default:
                    break;
            }
            return state;
        }

       /// <summary>
       /// 判断是否碰到边框或者敌方坦克
       /// </summary>
       /// <param name="type"></param>
       /// <returns></returns>
        public int Collide(MoveType type)
        {
            int tan = 0;

            //左
            if (type == MoveType.Left)
            {
                    if ( x <= 1)
                    {
                        tan = x;
                    }
                    else
                    {
                        if (From.Map[x - 2, y-1] == 3 || From.Map[x - 2, y] == 3 || From.Map[x - 2, y+1] == 3)
                        {
                            tan = x;
                        }
                        else
                        {
                            x -= 1;
                            tan = x;
                        }
                       
                    }
            }

            //右
            if (type == MoveType.Right)
            {
                    if (x >= From.Width - width + 1)
                    {
                        tan = x;
                    }
                    else
                    {
                        if (From.Map[x + 2, y-1] == 3 || From.Map[x + 2, y] == 3 || From.Map[x + 2, y+1] == 3)
                        {
                            tan = x;
                        }
                        else
                        {
                            x += 1;
                            tan = x;
                        }
                       
                    }
            }
            //上
            if (type == MoveType.Up)
            {

                if (y <= 1)
                {
                    tan = y;
                }
                else
                {
                    if (From.Map[x - 1, y - 2] == 3 || From.Map[x, y - 2] == 3 || From.Map[x + 1, y - 2] == 3)
                    {
                        tan = y;
                    }
                    else
                    {
                        y -= 1;
                        tan = y;
                    }
                   
                }
            }
            //下
            if (type == MoveType.Down)
            {
                if ( y > From.Height - 3)
                    {
                        tan = y;
                    }
                    else
                    {
                        if (From.Map[x - 1, y + 2] == 3 || From.Map[x, y + 2] == 3 || From.Map[x + 1, y + 2] == 3)
                        {
                            tan = y;
                        }
                        else
                        {
                            y += 1;
                            tan = y;
                        }
                      
                    }
            }

            return tan;
        }

        /// <summary>
        /// 坦克移动
        /// </summary>
        /// <param name="type"></param>
        public void Move(MoveType type)
        {
            if (type == MoveType.Left)
            {
              
                Draw(MoveType.Left);
                Direction d=new Direction (MoveType.Left);
                
                Direction = d;

            }
            if (type == MoveType.Right)
            {
              
                Draw(MoveType.Right);
                Direction d = new Direction(MoveType.Right);
                Direction = d;
               
            }
            if (type == MoveType.Up)
            {
               
                Draw(MoveType.Up);
                Direction d = new Direction(MoveType.Up);
                Direction = d;
            }
            if (type == MoveType.Down)
            {
              
                Draw(MoveType.Down);
                Direction d = new Direction(MoveType.Down);
                //ball.Direction = d;
                Direction = d;
            }
        }

       /// <summary>
       /// 清除移动后轨迹
       /// </summary>
       /// <param name="type"></param>
        public  void Clear(MoveType type)
        {
            lock (From.Map)
            {
                for (int i = 0; i <  3; i++)
                {
                    for (int j = 0; j < 3; j++)
                    {
                        if (type == MoveType.Left || type == MoveType.Right)
                        {
                            Console.SetCursorPosition(x * 2 + i*2, y + 3 - j - 1);
                            
                        }
                        else if (type == MoveType.Up)
                        {
                            Console.SetCursorPosition(x * 2 + i * 2, y + j);
                        }
                        else if (type == MoveType.Down)
                        {
                            Console.SetCursorPosition(x * 2 + i * 2, y + j );
                        }
                        Console.Write("  ");
                        From.Map[x + i-1, y+j-1] = 0;
                    }
                }
               
            }
        }
    }
}
